%option noyywrap
%{
#include <string.h>
#include "asmtypes.h"
#include "dasmbis.h"

extern char *reg8_tbl[], *reg16_tbl[], *reg32_tbl[];
int lookup_tbl( char **tbl, char *it );
%}
CMD0	aaa|aad|aam|aas|cbw|cwd|cwde|cdq|leave|popad|pushad|ret|xlat
CMD	adc|add|and|call|dec|in|inc|jo|jno|je|jne|jbe|jnbe|js|jns|jp|jnp|jl|jnl|jle|jnle|lea|mov|movsx|movzx|neg|not|or|out|pop|push|ret|sbb|sub|test|xchg|xor
REG8	ah|al|bh|bl|ch|cl|dh|dl
REG16	ax|bx|cx|dx|sp|bp|si|di
REG32	eax|ebx|ecx|edx|esp|ebp|esi|edi
SCALE	(0x)?[248]
DISP	(0x[0-9A-Fa-f]{1,8})|([0-9]{1,10})
SPACE	[ \t]+

%%
{CMD}/{SPACE}	{
		yylval.text = strdup(yytext);
		return cmd; 
	}
{CMD0}	{
		yylval.text = strdup(yytext);
		return cmd; 
	}
{REG8}	{
		yylval.intval = lookup_tbl( reg8_tbl, yytext );
		return reg8;
	}
{REG16}	{
		yylval.intval = lookup_tbl( reg16_tbl, yytext );
		return reg16;
	}
{REG32}	{
		yylval.intval = lookup_tbl( reg32_tbl, yytext );
		return reg32;
	}
{SCALE} {
		yylval.intval = strtol( yytext, 0, 0 );
		return scale_tk;
	}
{DISP}	{
		char *ep;
		yylval.intval = strtol( yytext, &ep, 10 );
		if ( *ep == 'x' )
			yylval.intval = strtol( yytext, 0, 16 );
		
		return int32;
	}
{SPACE}	/* nothing */
.	{ return *yytext; }
%%

